
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

static void Error(msg)
char        *msg;
	{
		fputs(msg,stderr);
		fputc('\n',stderr);
		exit(1);
	}

/*----------------------------------------------------------------------*/


int	main(argc,argv)
int	argc;
char	**argv;
{
	int		Nx,Ny,BPS;
	long	vv,hh;
	Cell	**cell1, **cell2, **cell3;
	char	*desc1, *desc2;
	int		ofset;

	if (argc!=5) {
	    fputs("usage : tif_ave input1.tif input2.tif output.tif offset\n",stderr);
	    exit(1);
	}

	ReadImageFile(argv[1],&Nx,&Ny,&BPS,&cell1,&desc1);
	ReadImageFile(argv[2],&Nx,&Ny,&BPS,&cell2,&desc2);

//	if(BPS==12){
//		BPS=16;
//		printf("12 bits image was converted to 16bits image.");
//	}

// initialize cell3
	if ((cell3=(Cell **)malloc(Ny*sizeof(*cell3)))==NULL)
		Error("cell memory allocation error (1).");
	for (vv=0; vv<Ny; vv++) {
		if ((cell3[vv]=(Cell *)malloc(Nx*sizeof(**cell3)))==NULL)
		Error("cell memory allocation error (2).");
	}
	
	ofset=atoi(argv[4]);

	for (vv=0; vv<Ny; vv++){			// vertical loop (in reconstructed image)
		for (hh=0; hh<Nx; hh++){		// horizontal loop
			cell3[vv][hh] = (cell1[vv][hh]-cell2[vv][hh])+ofset;
		}
	}

	StoreTiffFile(argv[3],Nx,Ny,BPS,cell3,desc1);

	return 0;
}
